From 741d748a83a75310d1fcee671550c35030eb417d Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: May 21 2015 18:03:56 +0000
Subject: [PATCH 20/1001] Expose JSON data for widgets.


---

diff --git a/hubs/app.py b/hubs/app.py
index 4e1e666..e9510f9 100644
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -59,10 +59,21 @@ def get_widget(session, hub, idx):
 
 @app.route('/<hub>/<idx>')
 @app.route('/<hub>/<idx>/')
-def widget(hub, idx):
+def widget_render(hub, idx):
     session = models.init(app.config['DB_URL'])
     widget = get_widget(session, hub, idx)
-    return widget.render(session, hub, idx)
+    return widget.render(flask.request, session)
+
+
+@app.route('/<hub>/<idx>/json')
+@app.route('/<hub>/<idx>/json/')
+def widget_json(hub, idx):
+    session = models.init(app.config['DB_URL'])
+    widget = get_widget(session, hub, idx)
+    from hubs.widgets import registry
+    module = registry[widget.plugin]
+    data = module.data(flask.request, session, widget, **widget.config)
+    return flask.jsonify(data)
 
 
 @app.route('/source/<name>')

